// CUSTOMERIMPL.H : Declaration of the TCustomerImpl

#ifndef CustomerImplH
#define CustomerImplH

#include "DataModBcb_TLB.h"
#include "DM.H"

/////////////////////////////////////////////////////////////////////////////
// TCustomerImpl     Implements ICustomer, default interface of Customer
// ThreadingModel : Apartment
// Dual Interface : TRUE
// Event Support  : FALSE
// Default ProgID : ModalWinBcb.Customer
// Description    : 
/////////////////////////////////////////////////////////////////////////////
class ATL_NO_VTABLE TCustomerImpl : 
  public CComObjectRootEx<CComSingleThreadModel>,
  public CComCoClass<TCustomerImpl, &CLSID_Customer>,
  public IDispatchImpl<ICustomer, &IID_ICustomer, &LIBID_DataModBcb>
{
public:
  // data module
  TDataModule1* DataModule1;

  // create data module
  TCustomerImpl()
  {
    ShowMessage("Impl Constructor");
    DataModule1 = new TDataModule1(NULL);
  }

  // destroy data module
  ~TCustomerImpl()
  {
    delete DataModule1;
    ShowMessage("Impl Destructor");
  }

  // Data used when registering Object
  //
  DECLARE_THREADING_MODEL(otApartment);
  DECLARE_PROGID("DataModBcb.Customer");
  DECLARE_DESCRIPTION("");

  // Function invoked to (un)register object
  //
  static HRESULT WINAPI UpdateRegistry(BOOL bRegister)
  {
    TTypedComServerRegistrarT<TCustomerImpl>
    regObj(GetObjectCLSID(), GetProgID(), GetDescription());
    return regObj.UpdateRegistry(bRegister);
  }


BEGIN_COM_MAP(TCustomerImpl)
  COM_INTERFACE_ENTRY(ICustomer)
  COM_INTERFACE_ENTRY2(IDispatch, ICustomer)
END_COM_MAP()

// ICustomer
public:

  STDMETHOD(ShowByZip(long handle, BSTR zip));
};

#endif //CustomerImplH
